--- os-prober/linux-boot-probes/mounted/x86/50lilo.orig
+++ os-prober/linux-boot-probes/mounted/x86/50lilo
@@ -85,14 +85,22 @@
 			image)
 				recordstanza
 				# Dereference if symbolic link
-				kernel="$(readlink -f "$(dequote "$2")")"
+				if echo "$2" | grep -qs "/boot/"; then
+					kernel="$(readlink -f "$(dequote "$mpoint$2")" | sed -e 's#'^$mpoint'##g')"
+				else
+					kernel="$(readlink -f "$(dequote "$mpoint/boot$2")" | sed -e 's#'^$mpoint'/boot##g')"
+				fi
 			;;
 			append)
 				addparams "$(dequote "${line#append=}")"
 			;;
 			initrd)
 				# Dereference if symbolic link
-				initrd="$(readlink -f "$(dequote "$2")")"
+				if echo "$2" | grep -qs "/boot/"; then
+					initrd="$(readlink -f "$(dequote "$mpoint$2")" | sed -e 's#'$mpoint'##g')"
+				else
+					initrd="$(readlink -f "$(dequote "$mpoint/boot$2")" | sed -e 's#'$mpoint'/boot##g')"
+				fi
 				;;
 			label)
 				shift 1
